<?php
namespace Myquest\Controller;

use Doctrine\DBAL\Connection;
use Zeedhi\Framework\DataSource\DataSet;

class ServicoController
{

    protected $entityManager;

    public function __construct($novoCodigo, $entityManager)
    {
        $this->novoCodigo = $novoCodigo;
        $this->entityManager = $entityManager;
    }

    public function getServicos($request, $response)
    {
        $sql = "SELECT NRCARDAPIO, S.IDTIPOSERV, S.CDFILIAL, S.CDSERVFILI, NVL(S.NMFANTASSERV, S.NMSERVICO) AS NMSERVICO, S.NRORG, CASE WHEN S.HRINICSERV IS NULL AND S.HRFINASERV IS NOT NULL THEN '00:00' WHEN S.HRINICSERV IS NULL AND S.HRFINASERV IS NULL THEN NULL ELSE SUBSTR(S.HRINICSERV, 0, 2) || ':' || SUBSTR(S.HRINICSERV, 3, 2) END AS HRINICIO, CASE WHEN S.HRFINASERV IS NULL THEN NULL ELSE SUBSTR(S.HRFINASERV, 0, 2) || ':' || SUBSTR(S.HRFINASERV, 3, 2) END AS HRFINAL, CASE WHEN S.HRINICATEN IS NULL THEN NULL ELSE SUBSTR(S.HRINICATEN, 0, 2) || ':' || SUBSTR(S.HRINICATEN, 3, 2) END AS HRINICIOPREPARO, S.FGFOTOSERVICO AS IMGSERVICO, NVL(S.NRDIASANT, 0) AS NRDIASANT, NVL(S.NRDIASPOS, 0) AS NRDIASPOS, NVL(S.NRLIMSEGPEDIDO, 0) AS NRLIMSEGPEDIDO, NVL(S.HRLIMSEGPEDIDO, '0000') AS HRLIMSEGPEDIDO, S.IDRESERVASERVMYMENU, ( SELECT AVG(VRAVALIACAOSERVICO) FROM AVALIACAOSERVICO V WHERE V.CDFILIAL = S.CDFILIAL AND V.CDSERVFILI = S.CDSERVFILI AND V.VRAVALIACAOSERVICO IS NOT NULL ) AS AVG_SERVICO, ( SELECT MAX(IDRESERVAMYMENU) FROM TABLE ( PRATOS_MYMENU(NULL, NULL, S.CDFILIAL, S.CDSERVFILI, 'N', NULL, :DTCARDAPIO, :NRORG) ) ) AS RESERVA_PRATO FROM SERVICO S INNER JOIN CARDADIA C ON C.CDFILIAL = S.CDFILIAL AND C.CDSERVFILI = S.CDSERVFILI AND C.DTCARDAPIO = :DTCARDAPIO AND C.DTCARDAPIO BETWEEN TRUNC(SYSDATE) - NVL(S.NRDIASANT, 0) AND TRUNC(SYSDATE) + NVL(S.NRDIASPOS, 0) LEFT JOIN SERVICOLOCALPESQ SLP ON SLP.CDFILIAL = S.CDFILIAL AND SLP.NRLOCALPESQ = :NRLOCALPESQ WHERE S.IDDISPONIVELMYMENU = 'S' AND S.CDFILIAL = :CDFILIAL AND ( CASE WHEN EXISTS ( SELECT SLPQ.CDSERVFILI FROM SERVICOLOCALPESQ SLPQ WHERE SLPQ.NRLOCALPESQ = :NRLOCALPESQ AND SLPQ.CDFILIAL = :CDFILIAL ) THEN SLP.CDSERVFILI ELSE S.CDSERVFILI END ) = S.CDSERVFILI AND S.NRORG = :NRORG AND ( EXISTS ( SELECT CP.NRCARDAPIO FROM COMPCARD CP WHERE CP.CDFILIAL = C.CDFILIAL AND CP.NRCARDAPIO = C.NRCARDAPIO ) OR EXISTS ( SELECT CPP.NRCARDAPIO FROM COMPCARDPESQ CPP WHERE CPP.CDFILIAL = C.CDFILIAL AND CPP.NRCARDAPIO = C.NRCARDAPIO AND CPP.IDEXIBEPRATOPESQ = 'S' ) ) ORDER BY CDSERVFILI";
        $conn = $this
            ->entityManager
            ->getConnection();
        $row = $request->getRow();
        $params = ['NRORG' => $row['NRORG'], 'CDFILIAL' => $row['CDFILIAL'], 'DTCARDAPIO' => $row['DTCARDAPIO'], 'NRLOCALPESQ' => $row['NRLOCALPESQ']];

        $statement = $conn->prepare($sql);
        $statement->execute($params);

        $result = $statement->fetchAll();
        $response->addDataSet(new DataSet('servico', $result));
    }

    public function insertReservaServico($request, $response)
    {
        $sql = "INSERT INTO AVALIACAOSERVICO (NRAVALIACAOSERVICO, IDCONSUMO, CDFILIAL, CDSERVFILI, NRCARDAPIO, DTCARDAPIO, NRORG, NMUSUARIO, DSCONSUMO, HRCONSUMO, NRLOCALPESQ) VALUES (:NRAVALIACAOSERVICO, :IDCONSUMO, :CDFILIAL, :CDSERVFILI, :NRCARDAPIO, :DTCARDAPIO, :NRORG, :NMUSUARIO, :DSCONSUMO, :HRCONSUMO, :NRLOCALPESQ)";
        $conn = $this
            ->entityManager
            ->getConnection();
        $row = $request->getRow();
        
        $NRAVALIACAOSERVICO = $this
                        ->novoCodigo
                        ->getCodeByTableName('AVALIACAOSERVICO', $row['NRORG'], 1, 10, false);
        $params = [
            'NRAVALIACAOSERVICO' => $NRAVALIACAOSERVICO,
            'IDCONSUMO' => "S",
            'CDFILIAL' => $row['CDFILIAL'],
            'CDSERVFILI' => $row['CDSERVFILI'],
            'NRCARDAPIO' => $row['NRCARDAPIO'],
            'DTCARDAPIO' => $row['DTCARDAPIO'],
            'NRORG' => $row['NRORG'],
            'NMUSUARIO' => $row['NMUSUARIO'],
            'DSCONSUMO' => $row['DSCONSUMO'],
            'HRCONSUMO' => $row['HRCONSUMO'],
            'NRLOCALPESQ' => $row['NRLOCALPESQ']
        ];

        $statement = $conn->prepare($sql);

        $statement->execute($params);

    }

    protected function executeInsertSql($sql, $params = null)
    {
        $conn = $this->entityManager->getConnection();
        $statement = $conn->prepare($sql);
        $statement->execute($params);
    }

    public function rateService($request, $response){
        $sql = "INSERT INTO AVALIACAOSERVICO (NRAVALIACAOSERVICO, IDCONSUMO, CDFILIAL, CDSERVFILI, NRCARDAPIO, DTCARDAPIO, NRORG, NRLOCALPESQ, VRAVALIACAOSERVICO) VALUES (:NRAVALIACAOSERVICO, :IDCONSUMO, :CDFILIAL, :CDSERVFILI, :NRCARDAPIO, :DTCARDAPIO, :NRORG, :NRLOCALPESQ, :VRAVALIACAOSERVICO)";
        $conn = $this
            ->entityManager
            ->getConnection();
        $row = $request->getRow();
        
        $NRAVALIACAOSERVICO = $this
                        ->novoCodigo
                        ->getCodeByTableName('AVALIACAOSERVICO', $row['NRORG'], 1, 10, false);
        $params = [
            'NRAVALIACAOSERVICO' => $NRAVALIACAOSERVICO,
            'IDCONSUMO' => "N",
            'CDFILIAL' => $row['CDFILIAL'],
            'CDSERVFILI' => $row['CDSERVFILI'],
            'NRCARDAPIO' => $row['NRCARDAPIO'],
            'DTCARDAPIO' => $row['DTCARDAPIO'],
            'NRORG' => $row['NRORG'],
            'NRLOCALPESQ' => $row['NRLOCALPESQ'],
            'VRAVALIACAOSERVICO' => $row['rateValue']
        ];

        $statement = $conn->prepare($sql);

        $statement->execute($params);
    }
}